.include "C:\Program Files\Atmel\AVR Tools\AvrStudio4\def\2313def.inc"
.def	tmp 		= r16
.def	tm1		= r17
.def	datrs		= r18
.def	num_sms		= r19
.def	oxrana_flag	= r20
.def	avariya_flag= r21
.def	RxTimOvf	= r22
.def	t_low 		= r23
.def	t_high		= r24

.equ	aCMD		= $60
.equ	cmdE		= $45
.equ	cmdR		= $52
.equ	cmdI		= $49
.equ	cmdO		= $4F
.equ	cmdK		= $4B
.equ	t2h		= $1e0		; 2 chasa
.equ	t48h		= $4380		; 3 cutok
.equ	t5m		= $14
.equ	t10m		= $28
.equ	RXD 		= PD0
.equ	TXD 		= PD1
.equ	oxrana 		= PD2
.equ	avariya 	= PD3
.equ	test 		= PD4
.equ	hl 		= PB0
.equ	alarm 		= PB1
.equ	batt 		= PB2
.cseg
.org	0
	rjmp RESET      		;  
 	nop	;rjmp EXT_INT0   	;  IRQ0
 	nop	;rjmp EXT_INT1   	;  IRQ1
 	nop	;rjmp TIM_CAPT1  	;    1
 	nop	;rjmp TIM1_COMP  	;    1
 	rjmp TIM_OVF1			;    1
 	rjmp TIM_OVF0			;    0
 	rjmp UART_RXC	  	 	;   
 	nop	;rjmp UART_DRE   	;   UDR
 	nop	;rjmp UART_TXC   	;   
 	nop	;rjmp ANA_COMP   	;   

RESET:
	ldi	tmp,low(RAMEND)
	out	SPL,tmp

	clr	tmp
	out	DDRD,tmp
	out	PORTB,tmp
	ser	tmp
	out	PORTD,tmp
	out	DDRB,tmp
	out	PIND,tmp

	ldi	tmp,15
	out	WDTCR,tmp

	ldi	tmp,25					;  9600  4000000
	out	UBRR,tmp
	clr	datrs
	ldi	datrs,(1<<TXEN)+(1<<RXEN)+(1<<RXCIE)
	out	UCR,datrs

	ldi	tmp,HIGH($10000-$e4e2)	;15 sek
	out	TCNT1H,tmp
	ldi	tmp,LOW($10000-$e4e2)
	out	TCNT1L,tmp
	ldi	tmp,5
	out	TCCR1B,tmp				;F/1024
	clr	tmp
	ldi	tmp,(1<<TOIE1)
	out	TIMSK,tmp

	clr	oxrana_flag
	clr	avariya_flag
	clr	RxTimOvf
	clr	tmp
	clr	datrs
	clr	num_sms
	clr	tm1
	clr	ZL
	clr	ZH

	sei
	clt

;-**********************************************-
; 
main:
	wdr

	tst	RxTimOvf
	breq	next1
	rcall	get_uart_cmd
next1:

	sbis	PIND,oxrana
	rcall	load_oxrana_uart

	sbis	PIND,avariya
	rcall	load_avariya_uart

	sbis	PIND,test
	rcall	load_test_uart

	sbic	PIND,avariya
 	clr	avariya_flag
	sbic	PIND,oxrana
	clr	oxrana_flag

	clt
	rjmp	main

;-**********************************************-
;    15 
TIM_OVF1:
	in	t_low,SREG
	push	t_low
	cli

	ldi	t_low,HIGH($10000-$e4e2)	;15 sek
	out	TCNT1H,t_low
	ldi	t_low,LOW($10000-$e4e2)
	out	TCNT1L,t_low
	ldi	t_low,5
	out	TCCR1B,t_low			;F/1024

	adiw	ZH:ZL,1
	ldi	t_low,low(1)
	ldi	t_high,high(1)
	cp	ZL,t_low
	cpc	ZH,t_high
	breq	start_charging

	ldi	t_low,low(t2h)
	ldi	t_high,high(t2h)
	cp	ZL,t_low
	cpc	ZH,t_high
	breq	stop_charging

	ldi	t_low,low(t48h)
	ldi	t_high,high(t48h)
	cp	ZL,t_low
	cpc	ZH,t_high
	breq	reset_timer

	rjmp	end_timer

start_charging:
	sbi	PORTB,batt
	rjmp	end_timer

stop_charging:
	cbi	PORTB,batt
	rjmp	end_timer

reset_timer:
	clr	ZL
	clr	ZH
	rjmp	end_timer

end_timer:
	pop	t_low
	out	SREG,t_low
	set
	reti

;-**********************************************-
;    1- 
UART_RXC:
	in	tm1,SREG
	push	tm1

	clr	RxTimOvf
	clr	tm1
	ldi	YL,LOW(aCMD)
	ldi	YH,HIGH(aCMD)
	in	datrs,UDR
	st	Y +,datrs

	dec	RxTimOvf
	out	TCCR0,tm1
	ldi	tm1,256-137		;137*1024/4 000 000=0.035c
	out	TCNT0,tm1
	in	tm1,TIMSK
	sbr	tm1,1<<TOIE0
	out	TIMSK,tm1
	ldi	tm1,5
	out	TCCR0,tm1		; 1/1024
	cbi	UCR,RXCIE

	pop	tm1
	out	SREG,tm1
	reti

;-**********************************************-
;    0.   
TIM_OVF0:
	clr	RxTimOvf
	out	TCCR0,RxTimOvf
	in	tm1,TIMSK
	cbr	tm1,1<<TOIE0
	out	TIMSK,tm1
	reti
; -===============      ===============-


;-**********************************************-
load_oxrana_uart:
	tst	oxrana_flag
	brne	end_oxrana

	sbi	PORTB,hl
	ser	oxrana_flag

;  30    
	ldi	tmp,60
more1:
	rcall	delay500ms
	dec	tmp
	brne	more1

	rcall	init_sms
	ldi	num_sms,1
	rcall	send_sms
	ldi	num_sms,2
	rcall	send_sms

	rcall	alarm_1000Hz

end_oxrana:
	cbi	PORTB,hl
	set
	ret

;-**********************************************-
load_avariya_uart:
	tst	avariya_flag
	brne	end_avariya

	sbi	PORTB,hl
	ldi	avariya_flag,$ff

	rcall	init_sms
	ldi	num_sms,3
	rcall	send_sms
	ldi	num_sms,4
	rcall	send_sms

end_avariya:
	cbi	PORTB,hl
	set
	ret

;-**********************************************-
load_test_uart:
	sbi	PORTB,hl

;   2 
	ldi	tmp,240
more2:
	rcall	delay500ms
	dec	tmp
	brne	more2

	rcall	init_sms

	ldi	num_sms,5			;   

	sbis	PIND,oxrana			;  
	ldi	num_sms,6

	sbis	PIND,avariya		;  
	ldi	num_sms,7

	ser	tmp
	cp	oxrana_flag,tmp
	cpc	avariya_flag,tmp
	brne	next2
	ldi	num_sms,8			;    

next2:
	rcall	send_sms

	cbi	PORTB,hl
	sbi	UCR,RXCIE
	clr	RxTimOvf
	rjmp	main
	ret

;-**********************************************-
;      
get_uart_cmd:
	rcall	RxCh
	st	Y +,datrs
	tst	RxTimOvf
	brne	get_uart_cmd
	rcall	RcgCmd
	ret

;-**********************************************-
;    RS-232
RxCh:
	wdr
	sbis	USR,RXC
	rjmp	RxCh
	in	datrs,UDR
	ret
; RxCh

;-**********************************************-
;    RS-232
TxCh:
	wdr
	sbis	USR,UDRE
	rjmp	TxCh
	out	UDR,datrs
	ret
; TxCh

;-**********************************************-
;    "RI"
RcgCmd:
	ldi	YL,LOW(aCMD)
	ldi	YH,HIGH(aCMD)
	ld	datrs,Y +
	cpi	datrs,cmdR
	brne	step_1
	ld	datrs,Y +
	cpi	datrs,cmdI
	brne	step_1
	rcall	load_test_uart
	rjmp	end_rcgcmd

step_1:
	wdr
	ldi	YL,LOW(aCMD)
	ldi	YH,HIGH(aCMD)
	ld	datrs,Y +
	ld	datrs,Y +
	cpi	datrs,cmdR
	brne	step_2
	ld	datrs,Y +
	cpi	datrs,cmdI
	brne	step_2
	rcall	load_test_uart
	rjmp	end_rcgcmd
	
step_2:
	wdr
	ldi	YL,LOW(aCMD)
	ldi	YH,HIGH(aCMD)
	ld	datrs,Y +
	ld	datrs,Y +
	ld	datrs,Y +
	cpi	datrs,cmdR
	brne	step_3
	ld	datrs,Y +
	cpi	datrs,cmdI
	brne	step_3
	rcall	load_test_uart
	rjmp	end_rcgcmd

step_3:
	wdr
	ldi	YL,LOW(aCMD)
	ldi	YH,HIGH(aCMD)
	ld	datrs,Y +
	ld	datrs,Y +
	ld	datrs,Y +
	ld	datrs,Y +
	cpi	datrs,cmdR
	brne	end_rcgcmd
	ld	datrs,Y +
	cpi	datrs,cmdI
	brne	end_rcgcmd
	rcall	load_test_uart
	rjmp	end_rcgcmd

end_rcgcmd:
	ret

;-**********************************************-
;  
; AT+CSCS="GSM"
; AT+CSCA="+73519030100"
; AT+CPMS="SM"
init_sms:
	ldi		datrs,65	;A
	rcall	TxCh
	ldi		datrs,84	;T
	rcall	TxCh
	ldi		datrs,43	;+
	rcall	TxCh
	ldi		datrs,67	;C
	rcall	TxCh
	ldi		datrs,83	;S
	rcall	TxCh
	ldi		datrs,67	;C
	rcall	TxCh
	ldi		datrs,83	;S
	rcall	TxCh
	ldi		datrs,61	;=
	rcall	TxCh
	ldi		datrs,34	;"
	rcall	TxCh
	ldi		datrs,71	;G
	rcall	TxCh
	ldi		datrs,83	;S
	rcall	TxCh
	ldi		datrs,77	;M
	rcall	TxCh
	ldi		datrs,34	;"
	rcall	TxCh
	ldi		datrs,13	;CR
	rcall	TxCh
	ldi		datrs,10	;LF
	rcall	TxCh

	rcall	delay500ms
	rcall	delay500ms
	rcall	delay500ms
	rcall	delay500ms

	ldi		datrs,65	;A
	rcall	TxCh
	ldi		datrs,84	;T
	rcall	TxCh
	ldi		datrs,43	;+
	rcall	TxCh
	ldi		datrs,67	;C
	rcall	TxCh
	ldi		datrs,83	;S
	rcall	TxCh
	ldi		datrs,67	;C
	rcall	TxCh
	ldi		datrs,65	;A
	rcall	TxCh
	ldi		datrs,61	;=
	rcall	TxCh
	ldi		datrs,34	;"
	rcall	TxCh
	ldi		datrs,43	;+
	rcall	TxCh
	ldi		datrs,55	;7
	rcall	TxCh
	ldi		datrs,51	;3
	rcall	TxCh
	ldi		datrs,53	;5
	rcall	TxCh
	ldi		datrs,49	;1
	rcall	TxCh
	ldi		datrs,57	;9
	rcall	TxCh
	ldi		datrs,48	;0
	rcall	TxCh
	ldi		datrs,51	;3
	rcall	TxCh
	ldi		datrs,48	;0
	rcall	TxCh
	ldi		datrs,49	;1
	rcall	TxCh
	ldi		datrs,48	;0
	rcall	TxCh
	ldi		datrs,48	;0
	rcall	TxCh
	ldi		datrs,34	;"
	rcall	TxCh
	ldi		datrs,13	;CR
	rcall	TxCh
	ldi		datrs,10	;LF
	rcall	TxCh

	rcall	delay500ms
	rcall	delay500ms
	rcall	delay500ms
	rcall	delay500ms

	ldi		datrs,65	;A
	rcall	TxCh
	ldi		datrs,84	;T
	rcall	TxCh
	ldi		datrs,43	;+
	rcall	TxCh
	ldi		datrs,67	;C
	rcall	TxCh
	ldi		datrs,80	;P
	rcall	TxCh
	ldi		datrs,77	;M
	rcall	TxCh
	ldi		datrs,83	;S
	rcall	TxCh
	ldi		datrs,61	;=
	rcall	TxCh
	ldi		datrs,34	;"
	rcall	TxCh
	ldi		datrs,83	;S
	rcall	TxCh
	ldi		datrs,77	;M
	rcall	TxCh
	ldi		datrs,34	;"
	rcall	TxCh
	ldi		datrs,13	;CR
	rcall	TxCh
	ldi		datrs,10	;LF
	rcall	TxCh

	rcall	delay500ms
	rcall	delay500ms

	ret

;-**********************************************-
; AT+CMSS=num_sms
send_sms:
	ldi		datrs,65	;A
	rcall	TxCh
	ldi		datrs,84	;T
	rcall	TxCh
	ldi		datrs,43	;+
	rcall	TxCh
	ldi		datrs,67	;C
	rcall	TxCh
	ldi		datrs,77	;M
	rcall	TxCh
	ldi		datrs,83	;S
	rcall	TxCh
	ldi		datrs,83	;S
	rcall	TxCh
	ldi		datrs,61	;=
	rcall	TxCh

	ldi		datrs,48
	add		datrs,num_sms
	rcall	TxCh

	ldi		datrs,13	;CR
	rcall	TxCh
	ldi		datrs,10	;LF
	rcall	TxCh

	rcall	delay500ms
	rcall	delay500ms

	ret

;-**********************************************-
;  1 
alarm_1000Hz:
	ldi		tmp,60
more4:
	ldi		XL,low(500)
	ldi		XH,high(500)
more3:
	sbi		PORTB,alarm
	rcall	delay05ms
	cbi		PORTB,alarm
	rcall	delay05ms
	sbiw	XL,1
	brne 	more3
	rcall	delay500ms

	dec		tmp
	brne	more4
	
	ret

;-**********************************************-
;  delay
;    0,5 
delay05ms:
	wdr
	ldi	Yl,low(497)
	ldi	YH,high(497)

d05_1:
	sbiw	YL,1		;  YH:YL 
	brne	d05_1		; Z!=0   d05_1
	ret

;-**********************************************-
;    0,5 
delay500ms:
	ldi	XL,low(1000)
	ldi	XH,high(1000)

d500_1:
	rcall	delay05ms
	sbiw	XL,1
	brne	d500_1
	ret

